import { extractSmartLinkUrl } from '@atlaskit/link-extractors';
import { InternalActionName } from '../../../constants';
import { getDefinitionId, getExtensionKey, getResourceType } from '../../../state/helpers';
import { canShowAction } from '../../../utils/actions/can-show-action';
import { getIsRovoChatEnabled } from '../../../utils/rovo';
import { CardAction } from '../../../view/Card/types';
var extractRovoChatAction = function extractRovoChatAction(_ref) {
  var _actionOptions$rovoCh;
  var actionOptions = _ref.actionOptions,
    appearance = _ref.appearance,
    id = _ref.id,
    product = _ref.product,
    response = _ref.response,
    rovoConfig = _ref.rovoConfig;
  if (!canShowAction(CardAction.RovoChatAction, actionOptions)) {
    return;
  }
  var isRovoChatEnabled = getIsRovoChatEnabled(rovoConfig);
  if (!isRovoChatEnabled) {
    return;
  }

  // Experiment cleanup note: platform_sl_3p_auth_rovo_action
  // If feature isn't support all 3P, this value should come from meta.supportedFeature
  var isSupportedFeature = getExtensionKey(response) === 'google-object-provider';
  var isOptIn = (actionOptions === null || actionOptions === void 0 || (_actionOptions$rovoCh = actionOptions.rovoChatAction) === null || _actionOptions$rovoCh === void 0 ? void 0 : _actionOptions$rovoCh.optIn) === true;
  var url = extractSmartLinkUrl(response);
  return isSupportedFeature && isOptIn ? {
    invokeAction: {
      actionSubjectId: 'rovoChatPrompt',
      actionType: InternalActionName.RovoChatAction,
      definitionId: getDefinitionId(response),
      display: appearance,
      extensionKey: getExtensionKey(response),
      id: id,
      resourceType: getResourceType(response)
    },
    product: product,
    url: url
  } : undefined;
};
export default extractRovoChatAction;